All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.dataselectors.calculateditems
Class BaseCalculatedObjectFactory

    com.sas.dataselectors.calculateditems.BaseCalculatedObjectFactory

All Implemented Interfaces:
  CalculatedItemMetadataInterface, CalculatedObjectFactoryInterface

Direct Known Subclasses:
  BusinessModelCalculatedObjectFactory, BusinessQueryCalculatedObjectFactory

    public abstract class BaseCalculatedObjectFactory

implements CalculatedObjectFactoryInterface

Description: Factory (sort of) for creating, updating, and managing objects between the BusinessModel and the CalculatedItem classes Copyright: Copyright (c) 2002 Company: SAS

Nested Class Summary

Nested classes/interfaces inherited from interface com.sas.dataselectors.calculateditems.CalculatedObjectFactoryInterface
`CalculatedObjectFactoryInterface.ImageIconFactoryInterface`

Field Summary
`java.util.Map` | `_cachedChildrenLists`
`protected boolean` | `_isTypeChangeWarningIgnored`
`protected int` | `_maxPhysicalValuestoLoad`
`protected java.util.Map` | `_timeDateLookupCache`
`protected com.sas.iquery.metadata.business.DataSelection` | `_timeDateSyntaxDataSelection`
`static int` | `DEFAULT_GOVERNING_LIMIT`
`static java.lang.String` | `ERROR_ADDINGDATAITEM`
`static java.lang.String` | `ERROR_CREATINGDATAITEM`
`static java.lang.String` | `ERROR_FINDINGICONIMAGE`
`static java.lang.String` | `ERROR_FORMATTINGEXPRTEXT`
`static java.lang.String` | `ERROR_INVALIDEXPR`
`static java.lang.String` | `ERROR_INVALIDITEM`
`static java.lang.String` | `ERROR_INVALIDITEM_LABEL`
`static java.lang.String` | `ERROR_INVALIDITEM_OLAPLABELLENGTH`
`static java.lang.String` | `ERROR_NODATASERVICES`
`static java.lang.String` | `ERROR_NOMETADATASERVICE`
`static java.lang.String` | `ERROR_PARSINGEXPRTEXT`
`static java.lang.String` | `ERROR_REMOVINGDATAITEM`
`static java.lang.String` | `ERROR_TYPEINVALID`
`static java.lang.String` | `ERROR_TYPENOTSET`
`static java.lang.String` | `ERROR_UPDATINGDATAITEM`
`static java.lang.String` | `ERROR_UPDATINGEXPR`
`static java.lang.String` | `IMAGENAME_COLUMN_TYPE_CHARACTER`
`static java.lang.String` | `IMAGENAME_COLUMN_TYPE_DATE`
`static java.lang.String` | `IMAGENAME_COLUMN_TYPE_NUMERIC`
`static java.lang.String` | `IMAGENAME_COLUMN_TYPE_TIME`
`static java.lang.String` | `IMAGENAME_COLUMN_TYPE_TIMESTAMP`
`static java.lang.String` | `IMAGENAME_FOLDER_CLOSED`
`static java.lang.String` | `IMAGENAME_FOLDER_OPENED`
`static java.lang.String` | `IMAGENAME_MEMBER_TYPE_CHARACTER`
`static java.lang.String` | `IMAGENAME_MEMBER_TYPE_DATE`
`static java.lang.String` | `IMAGENAME_MEMBER_TYPE_NUMERIC`
`static java.lang.String` | `IMAGENAME_MEMBER_TYPE_TIME`
`static java.lang.String` | `IMAGENAME_MEMBER_TYPE_TIMESTAMP`
`static java.lang.String` | `IMAGENAME_OBJECT_CATEGORY`
`static java.lang.String` | `IMAGENAME_OBJECT_COLLECTION`
`static java.lang.String` | `IMAGENAME_OBJECT_CUBE`
`static java.lang.String` | `IMAGENAME_OBJECT_CUBE_DIMENSION`
`static java.lang.String` | `IMAGENAME_OBJECT_CUBE_HIERARCHY`
`static java.lang.String` | `IMAGENAME_OBJECT_CUBE_LEVEL`
`static java.lang.String` | `IMAGENAME_OBJECT_CUBE_MEASURE`
`static java.lang.String` | `IMAGENAME_OBJECT_DATASET`
`static java.lang.String` | `IMAGENAME_OBJECT_DATASOURCE`
`static java.lang.String` | `IMAGENAME_OBJECT_DETAIL`
`static java.lang.String` | `IMAGENAME_OBJECT_FILTER`
`static java.lang.String` | `IMAGENAME_OBJECT_MEASURE`
`static java.lang.String` | `IMAGENAME_OBJECT_PROMPTED_CATEGORY`
`static java.lang.String` | `IMAGENAME_OBJECT_PROMPTED_DETAIL`
`static java.lang.String` | `IMAGENAME_OBJECT_PROMPTED_FILTER`
`static java.lang.String` | `IMAGENAME_OBJECT_PROMPTED_MEASURE`
`static java.lang.String` | `IMAGENAME_OBJECT_TYPE_COLUMN`
`static java.lang.String` | `IMAGENAME_OBJECT_TYPE_PROMPT`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_BITSTRING`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_BOOLEAN`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_CHARACTER`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_DATE`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_INTERVAL_DT`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_INTERVAL_YM`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_NOT_SET`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_NUMERIC`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_OLAP_CATEGORY`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_OLAP_MEASURE`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_TIME`
`static java.lang.String` | `LABEL_CALCITEM_TYPE_TIMESTAMP`
`java.lang.String` | `lastInvalidCalculatedItemMessage`
`java.lang.Exception` | `lastInvalidExpressionException`
`static int` | `MAXIMUM_OLAPLABELLENGTH`
`protected java.util.HashMap` | `parseExpressionMap`
`static java.lang.String` | `RB_KEY`

Constructor Summary
`BaseCalculatedObjectFactory(com.sas.iquery.metadata.business.BusinessModel businessModel, com.sas.iquery.metadata.expr.ResourceScope scope)` Constructor - using a businessModel that could be either a DataSelector or a InformationMap
`BaseCalculatedObjectFactory(com.sas.iquery.metadata.business.BusinessModel businessModel, com.sas.iquery.metadata.expr.ResourceScope scope, java.util.Locale locale)`

Method Summary
`protected void` | `_init()`
`boolean` | `canBusinessModelObjectHaveChildren(java.lang.Object bmObject)`
`boolean` | `canBusinessModelObjectHaveValues(java.lang.Object bmObject)`
`boolean` | `canRemoveAllCalculatedItems()`
`protected java.util.List` | `convertBusinessObjectListToValuesList(java.util.List businessObjects, java.lang.String formatString)`
`static int` | `convertToCalcItemType(int expressionType, boolean isOLAP)`
`protected com.sas.iquery.metadata.business.DataItem` | `convertToDataItem(CalculatedItemInterface calculatedItem)` Converts the specified calculated item to a data item.
`static int` | `convertToExpressionType(int calculatedItemType, boolean isOLAP)`
`protected void` | `finalize()`
`com.sas.expressions.visuals.DataSourceTreeInterface` | `getBusinessDataSourceTree()` Get the DataSource tree model from the Business (Data Item) view of the business model
`java.util.List` | `getBusinessModelCalculatedItemObjects(boolean includeBaseModels)`
`java.util.List` | `getBusinessModelObjectChildren(java.lang.Object bmObject)`
`java.lang.String` | `getBusinessModelObjectImageName(java.lang.Object value, boolean expanded)`
`java.util.List` | `getBusinessModelObjectValues(java.lang.Object bmObject)`
`java.lang.String` | `getBusinessModelObjectValuesToInsert(java.lang.Object item)`
`java.lang.String` | `getBusinessObjectDescription(java.lang.Object bmObject)`
`java.lang.String` | `getBusinessObjectDisplayName(java.lang.Object item)`
`java.lang.String` | `getBusinessObjectInsertName(java.lang.Object item)`
`java.lang.String` | `getBusinessObjectTipText(java.lang.Object bmObject)`
`static java.lang.String[]` | `getCalcItemTypeNames(boolean isOLAP)`
`static int[]` | `getCalcItemTypeValues(boolean isOLAP)`
`static java.util.List` | `getChildFormats(com.sas.iquery.metadata.business.DataItem dataItem, int restrictByType)` Returns a list of format strings used by the resources of this data item
`static java.util.List` | `getChildFormats(com.sas.iquery.metadata.expr.ExpressionInterface expression, int restrictByType)` Returns a list of format strings used by the resources of this data item
`java.util.List` | `getChildFormats(java.lang.String expressionText, int expressionType, int restrictByType)`
`java.util.List` | `getDataItems(boolean includeBaseModels)` returns a list of all the DataItems
`java.util.List` | `getDataItemsAndFolders(boolean includeBaseModels)`
`static java.util.List` | `getDataItemValues(com.sas.iquery.metadata.business.DataItem dataItem, int maxValues)`
`protected java.util.List` | `getDataServiceValues(com.sas.iquery.metadata.business.DataItem dataItem)`
`java.util.List` | `getDataSources(boolean includeBaseModels)` Returns a list of all logical getDataSources
`com.sas.expressions.visuals.DataSourceTreeInterface` | `getDataSourceTree()` Get the Default DataSource tree model for this business model
`static java.lang.String` | `getExpressionTypeLabel(int expressionType, boolean isOlap)`
`java.lang.String[]` | `getExpressionTypeNames()`
`int[]` | `getExpressionTypeValues()`
`java.lang.String` | `getExpressionUtilText(com.sas.iquery.metadata.expr.ExpressionInterface expression)`
`static java.util.List` | `getExpressionValues(com.sas.iquery.metadata.business.BusinessModel sourceModel, com.sas.iquery.metadata.expr.ExpressionInterface expression, int maxValues)`
`java.lang.String` | `getFormatFromResources(java.lang.Object bmObject)`
`com.sas.expressions.visuals.FunctionTreeInterface` | `getFunctionListTree()` Get the Category Tree with Function Lists model
`javax.swing.Icon` | `getImageIconByImageName(java.lang.String imageName)`
`CalculatedObjectFactoryInterface.ImageIconFactoryInterface` | `getImageIconFactory()`
`javax.swing.Icon` | `getImageIconFromIqVisualsBundle(java.lang.String imageName)`
`static com.sas.iquery.metadata.IntelligentQueryMetadataServiceInterface` | `getIQueryMetadataService(com.sas.iquery.metadata.business.BusinessModel businessModel)`
`java.lang.String` | `getLastInvalidCalculatedItemMessage()`
`java.lang.Exception` | `getLastInvalidExpressionException()`
`boolean` | `getLevelHasMembers()` Indicates whether or not the DataSelection for this factory contains levels which have members.
`java.util.Map` | `getLevelNameMap(boolean includeHierarchyName)` Gets the level names in a map with the Level Display names as the keys and the insertable text as the values.
`java.lang.String[]` | `getLevelNames(boolean includeHierarchyName)` get all the level names
`java.util.Locale` | `getLocale()`
`int` | `getMaxOutputObservations()` Returns the current maximum number of output observations returned when gathering a list of possible values for a data item or physical item in the data source tree.
`java.util.Map` | `getMeasureNameMap()` Gets the measure names and each insertable value.
`java.lang.String[]` | `getMeasureNames()` Gets the measure names.
`java.lang.String[]` | `getMemberNames(java.lang.String levelName)` Get the member names for a given level.
`com.sas.expressions.visuals.OperationListInterface` | `getOperationList()` Get the Operations List model
`com.sas.expressions.visuals.DataSourceTreeInterface` | `getPhysicalDataSourceTree()` Get the DataSource tree model from the Physical view of the business model
`com.sas.expressions.visuals.DataSourceTreeInterface` | `getPromptDataSourceTree()` Get the DataSource tree model containing the prompts of the business model
`com.sas.iquery.metadata.expr.ResourceScope` | `getResourceScope()`
`java.lang.String` | `getSimpleDisplayNameFormat()`
`java.lang.String` | `getSimpleDuplicateNameFormat()`
`int` | `getSimpleDuplicateStartIndex()`
`static boolean` | `isInterruptedGetPossibleFilterValues(com.sas.iquery.dataservices.DataServicesException e)`
`boolean` | `isTypeChangeWarningIgnored()`
`java.lang.Object` | `newBusinessModelCalculatedItemObject()`
`java.lang.Object` | `newBusinessModelCalculatedItemObject(CalculatedItemInterface item)`
`CalculatedItemInterface` | `newCalculatedItem(CalculatedItemInterface toBeCloned)`
`com.sas.iquery.metadata.expr.ExpressionInterface` | `newExpressionUtilExpression(java.lang.String text, int type)`
`com.sas.iquery.metadata.expr.ExpressionInterface` | `parseExpression(java.lang.String text, int type)`
`void` | `removeBusinessModelCalculatedItemObject(java.lang.Object bmObject)`
`static boolean` | `setFormat(com.sas.iquery.metadata.business.DataItem dataItem, java.lang.String format)` sets the format on the dataitem with checking to see if format is writable first
`void` | `setImageIconFactory(CalculatedObjectFactoryInterface.ImageIconFactoryInterface imageIconFactory)`
`void` | `setLocale(java.util.Locale locale)`
`void` | `setMaxOutputObservations(int max)` Sets the current maximum number of output observations to be returned when gathering a list of possible values for a data item or physical item in the data source tree.
`void` | `setResourceScope(com.sas.iquery.metadata.expr.ResourceScope scope)`
`void` | `setSimpleDisplayNameFormat(java.lang.String format)`
`void` | `setSimpleDuplicateNameFormat(java.lang.String format)`
`void` | `setSimpleDuplicateStartIndex(int index)`
`void` | `setTypeChangeWarningIgnored(boolean isTypeChangeWarningIgnored)`
`boolean` | `updateBusinessModelObjectFromCalculatedItem(java.lang.Object bmObject, CalculatedItemInterface item)`
`boolean` | `updateCalculatedItemFromBusinessModelObject(CalculatedItemInterface item, java.lang.Object bmObject)`
`boolean` | `updateCalculatedItemFromCalcValues(CalculatedItemInterface item, java.lang.String id, java.lang.String label, java.lang.String desc, int calcType, java.lang.String text)`
`boolean` | `updateCalculatedItemFromExprValues(CalculatedItemInterface item, java.lang.String id, java.lang.String label, java.lang.String desc, int exprType, java.lang.String text)`
`boolean` | `validateCalculatedItem(CalculatedItemInterface item)`
`boolean` | `validateCalculatedItem(CalculatedItemInterface item, boolean validateText)`
`boolean` | `validateCalculatedItemOnServer(CalculatedItemInterface calculatedItem)` Validates the specified calculated item on the server by building a corresponding data item and then calling down to IQ to validate the data item.
`static void` | `validateExpression(com.sas.iquery.metadata.business.BusinessModel sourceModel, com.sas.iquery.metadata.expr.ExpressionInterface expression)`
`boolean` | `validateExpression(com.sas.iquery.metadata.expr.ExpressionInterface expression)`
`boolean` | `validateItemCalculation(CalculatedItemInterface item)`
`boolean` | `validateItemCalculation(CalculatedItemInterface item, boolean validateTextOnServer)`

Methods inherited from interface com.sas.dataselectors.calculateditems.CalculatedObjectFactoryInterface
`newCalculatedItemFromBusinessObject`

Field Detail

### RB_KEY

    public static final java.lang.String RB_KEY

See Also:
  Constant Field Values

### parseExpressionMap

    protected java.util.HashMap parseExpressionMap

### ERROR_NOMETADATASERVICE

    public static java.lang.String ERROR_NOMETADATASERVICE

### ERROR_NODATASERVICES

    public static java.lang.String ERROR_NODATASERVICES

### ERROR_REMOVINGDATAITEM

    public static java.lang.String ERROR_REMOVINGDATAITEM

### ERROR_CREATINGDATAITEM

    public static java.lang.String ERROR_CREATINGDATAITEM

### ERROR_ADDINGDATAITEM

    public static java.lang.String ERROR_ADDINGDATAITEM

### ERROR_UPDATINGDATAITEM

    public static java.lang.String ERROR_UPDATINGDATAITEM

### ERROR_UPDATINGEXPR

    public static java.lang.String ERROR_UPDATINGEXPR

### ERROR_FINDINGICONIMAGE

    public static java.lang.String ERROR_FINDINGICONIMAGE

### ERROR_PARSINGEXPRTEXT

    public static java.lang.String ERROR_PARSINGEXPRTEXT

### ERROR_FORMATTINGEXPRTEXT

    public static java.lang.String ERROR_FORMATTINGEXPRTEXT

### _cachedChildrenLists

    public java.util.Map _cachedChildrenLists

### _timeDateSyntaxDataSelection

    protected com.sas.iquery.metadata.business.DataSelection _timeDateSyntaxDataSelection

### _timeDateLookupCache

    protected java.util.Map _timeDateLookupCache

### ERROR_TYPENOTSET

    public static java.lang.String ERROR_TYPENOTSET

### ERROR_TYPEINVALID

    public static java.lang.String ERROR_TYPEINVALID

### ERROR_INVALIDITEM

    public static java.lang.String ERROR_INVALIDITEM

### ERROR_INVALIDEXPR

    public static java.lang.String ERROR_INVALIDEXPR

### ERROR_INVALIDITEM_LABEL

    public static java.lang.String ERROR_INVALIDITEM_LABEL

### MAXIMUM_OLAPLABELLENGTH

    public static int MAXIMUM_OLAPLABELLENGTH

### ERROR_INVALIDITEM_OLAPLABELLENGTH

    public static java.lang.String ERROR_INVALIDITEM_OLAPLABELLENGTH

### lastInvalidCalculatedItemMessage

    public java.lang.String lastInvalidCalculatedItemMessage

### IMAGENAME_OBJECT_DATASOURCE

    public static java.lang.String IMAGENAME_OBJECT_DATASOURCE

### IMAGENAME_OBJECT_COLLECTION

    public static java.lang.String IMAGENAME_OBJECT_COLLECTION

### IMAGENAME_FOLDER_CLOSED

    public static java.lang.String IMAGENAME_FOLDER_CLOSED

### IMAGENAME_FOLDER_OPENED

    public static java.lang.String IMAGENAME_FOLDER_OPENED

### IMAGENAME_OBJECT_DATASET

    public static java.lang.String IMAGENAME_OBJECT_DATASET

### IMAGENAME_OBJECT_TYPE_COLUMN

    public static java.lang.String IMAGENAME_OBJECT_TYPE_COLUMN

### IMAGENAME_OBJECT_TYPE_PROMPT

    public static java.lang.String IMAGENAME_OBJECT_TYPE_PROMPT

### IMAGENAME_OBJECT_CUBE

    public static java.lang.String IMAGENAME_OBJECT_CUBE

### IMAGENAME_OBJECT_CUBE_LEVEL

    public static java.lang.String IMAGENAME_OBJECT_CUBE_LEVEL

### IMAGENAME_OBJECT_CUBE_DIMENSION

    public static java.lang.String IMAGENAME_OBJECT_CUBE_DIMENSION

### IMAGENAME_OBJECT_CUBE_HIERARCHY

    public static java.lang.String IMAGENAME_OBJECT_CUBE_HIERARCHY

### IMAGENAME_OBJECT_CUBE_MEASURE

    public static java.lang.String IMAGENAME_OBJECT_CUBE_MEASURE

### IMAGENAME_OBJECT_FILTER

    public static java.lang.String IMAGENAME_OBJECT_FILTER

### IMAGENAME_OBJECT_PROMPTED_FILTER

    public static java.lang.String IMAGENAME_OBJECT_PROMPTED_FILTER

### IMAGENAME_OBJECT_MEASURE

    public static java.lang.String IMAGENAME_OBJECT_MEASURE

### IMAGENAME_OBJECT_DETAIL

    public static java.lang.String IMAGENAME_OBJECT_DETAIL

### IMAGENAME_OBJECT_CATEGORY

    public static java.lang.String IMAGENAME_OBJECT_CATEGORY

### IMAGENAME_OBJECT_PROMPTED_MEASURE

    public static java.lang.String IMAGENAME_OBJECT_PROMPTED_MEASURE

### IMAGENAME_OBJECT_PROMPTED_DETAIL

    public static java.lang.String IMAGENAME_OBJECT_PROMPTED_DETAIL

### IMAGENAME_OBJECT_PROMPTED_CATEGORY

    public static java.lang.String IMAGENAME_OBJECT_PROMPTED_CATEGORY

### IMAGENAME_COLUMN_TYPE_CHARACTER

    public static java.lang.String IMAGENAME_COLUMN_TYPE_CHARACTER

### IMAGENAME_COLUMN_TYPE_NUMERIC

    public static java.lang.String IMAGENAME_COLUMN_TYPE_NUMERIC

### IMAGENAME_COLUMN_TYPE_DATE

    public static java.lang.String IMAGENAME_COLUMN_TYPE_DATE

### IMAGENAME_COLUMN_TYPE_TIME

    public static java.lang.String IMAGENAME_COLUMN_TYPE_TIME

### IMAGENAME_COLUMN_TYPE_TIMESTAMP

    public static java.lang.String IMAGENAME_COLUMN_TYPE_TIMESTAMP

### IMAGENAME_MEMBER_TYPE_CHARACTER

    public static java.lang.String IMAGENAME_MEMBER_TYPE_CHARACTER

### IMAGENAME_MEMBER_TYPE_NUMERIC

    public static java.lang.String IMAGENAME_MEMBER_TYPE_NUMERIC

### IMAGENAME_MEMBER_TYPE_DATE

    public static java.lang.String IMAGENAME_MEMBER_TYPE_DATE

### IMAGENAME_MEMBER_TYPE_TIME

    public static java.lang.String IMAGENAME_MEMBER_TYPE_TIME

### IMAGENAME_MEMBER_TYPE_TIMESTAMP

    public static java.lang.String IMAGENAME_MEMBER_TYPE_TIMESTAMP

### LABEL_CALCITEM_TYPE_NOT_SET

    public static java.lang.String LABEL_CALCITEM_TYPE_NOT_SET

### LABEL_CALCITEM_TYPE_BITSTRING

    public static java.lang.String LABEL_CALCITEM_TYPE_BITSTRING

### LABEL_CALCITEM_TYPE_NUMERIC

    public static java.lang.String LABEL_CALCITEM_TYPE_NUMERIC

### LABEL_CALCITEM_TYPE_CHARACTER

    public static java.lang.String LABEL_CALCITEM_TYPE_CHARACTER

### LABEL_CALCITEM_TYPE_DATE

    public static java.lang.String LABEL_CALCITEM_TYPE_DATE

### LABEL_CALCITEM_TYPE_TIME

    public static java.lang.String LABEL_CALCITEM_TYPE_TIME

### LABEL_CALCITEM_TYPE_TIMESTAMP

    public static java.lang.String LABEL_CALCITEM_TYPE_TIMESTAMP

### LABEL_CALCITEM_TYPE_INTERVAL_YM

    public static java.lang.String LABEL_CALCITEM_TYPE_INTERVAL_YM

### LABEL_CALCITEM_TYPE_INTERVAL_DT

    public static java.lang.String LABEL_CALCITEM_TYPE_INTERVAL_DT

### LABEL_CALCITEM_TYPE_BOOLEAN

    public static java.lang.String LABEL_CALCITEM_TYPE_BOOLEAN

### LABEL_CALCITEM_TYPE_OLAP_MEASURE

    public static java.lang.String LABEL_CALCITEM_TYPE_OLAP_MEASURE

### LABEL_CALCITEM_TYPE_OLAP_CATEGORY

    public static java.lang.String LABEL_CALCITEM_TYPE_OLAP_CATEGORY

### lastInvalidExpressionException

    public java.lang.Exception lastInvalidExpressionException

### DEFAULT_GOVERNING_LIMIT

    public static final int DEFAULT_GOVERNING_LIMIT

### _maxPhysicalValuestoLoad

    protected int _maxPhysicalValuestoLoad

### _isTypeChangeWarningIgnored

    protected boolean _isTypeChangeWarningIgnored

Constructor Detail

### BaseCalculatedObjectFactory

    public BaseCalculatedObjectFactory(com.sas.iquery.metadata.business.BusinessModel businessModel,
                                       com.sas.iquery.metadata.expr.ResourceScope scope)

  Constructor - using a businessModel that could be either a DataSelector or a InformationMap

### BaseCalculatedObjectFactory

    public BaseCalculatedObjectFactory(com.sas.iquery.metadata.business.BusinessModel businessModel,
                                       com.sas.iquery.metadata.expr.ResourceScope scope,
                                       java.util.Locale locale)

Method Detail

### _init

    protected void _init()

### getIQueryMetadataService

    public static com.sas.iquery.metadata.IntelligentQueryMetadataServiceInterface getIQueryMetadataService(com.sas.iquery.metadata.business.BusinessModel businessModel)

### setLocale

    public void setLocale(java.util.Locale locale)

### getLocale

    public java.util.Locale getLocale()

### getLevelHasMembers

    public boolean getLevelHasMembers()

  Indicates whether or not the DataSelection for this factory contains levels which have members.

  Specified by:
    `getLevelHasMembers` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getLevelHasMembers` in interface `CalculatedObjectFactoryInterface`
  Returns:
    true if this adapter contains data with members; false otherwise.
  See Also:
    `CalculatedItemMetadataInterface.getMemberNames(String)`

### getMeasureNames

    public java.lang.String[] getMeasureNames()

  Description copied from interface: `CalculatedItemMetadataInterface`
  Gets the measure names. Measure names are actual names of measures for OLAP, but are numeric type data items for relational.

  Specified by:
    `getMeasureNames` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getMeasureNames` in interface `CalculatedObjectFactoryInterface`
  Returns:
    an array of String containing the names of the measures

### getMeasureNameMap

    public java.util.Map getMeasureNameMap()

  Description copied from interface: `CalculatedItemMetadataInterface`
  Gets the measure names and each insertable value. Measure names are actual names of measures for OLAP, but are numeric type data items for relational.

  Specified by:
    `getMeasureNameMap` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getMeasureNameMap` in interface `CalculatedObjectFactoryInterface`
  Returns:
    an map of String containing the names of the measures mapped to the insertable value

### getLevelNames

    public java.lang.String[] getLevelNames(boolean includeHierarchyName)

  get all the level names

  Specified by:
    `getLevelNames` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getLevelNames` in interface `CalculatedObjectFactoryInterface`
  Parameters:
    `includeHierarchyName` - set to true if the hierarchy name for a given level is to be returned (only used if getLevelHasMembers() is true)
  Returns:
    an array of String containing the names of the levels, and optionally, the hierarchy name for each level.
  See Also:
    `CalculatedItemMetadataInterface.getLevelHasMembers()`

### getLevelNameMap

    public java.util.Map getLevelNameMap(boolean includeHierarchyName)

  Description copied from interface: `CalculatedItemMetadataInterface`
  Gets the level names in a map with the Level Display names as the keys and the insertable text as the values.

  Specified by:
    `getLevelNameMap` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getLevelNameMap` in interface `CalculatedObjectFactoryInterface`
  Parameters:
    `includeHierarchyName` - set to true if the hierarchy name for a given level is to be returned (only used if getLevelHasMembers() is true)
  Returns:
    a map of String containing the names of the levels, and optionally, the hierarchy name for each level to the insertable text
  See Also:
    `CalculatedItemMetadataInterface.getLevelHasMembers()`

### getMemberNames

    public java.lang.String[] getMemberNames(java.lang.String levelName)

  Description copied from interface: `CalculatedItemMetadataInterface`
  Get the member names for a given level. This method is only meaningful in the case where the level of data contains members (i.e. if getLevelHasMembers() returns true).

  Specified by:
    `getMemberNames` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getMemberNames` in interface `CalculatedObjectFactoryInterface`
  Parameters:
    `levelName` - the level for which to get the member names
  Returns:
    an array of Strings containing the names of the members for the specified level if the adapter contains OLAP data; returns null otherwise.
  See Also:
    `CalculatedItemMetadataInterface.getLevelHasMembers()`

### getSimpleDuplicateStartIndex

    public int getSimpleDuplicateStartIndex()

### setSimpleDuplicateStartIndex

    public void setSimpleDuplicateStartIndex(int index)

### getSimpleDuplicateNameFormat

    public java.lang.String getSimpleDuplicateNameFormat()

### setSimpleDuplicateNameFormat

    public void setSimpleDuplicateNameFormat(java.lang.String format)

### getSimpleDisplayNameFormat

    public java.lang.String getSimpleDisplayNameFormat()

### setSimpleDisplayNameFormat

    public void setSimpleDisplayNameFormat(java.lang.String format)

### getPhysicalDataSourceTree

    public com.sas.expressions.visuals.DataSourceTreeInterface getPhysicalDataSourceTree()

  Description copied from interface: `CalculatedItemMetadataInterface`
  Get the DataSource tree model from the Physical view of the business model

  Specified by:
    `getPhysicalDataSourceTree` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getPhysicalDataSourceTree` in interface `CalculatedObjectFactoryInterface`
  Returns:
    a com.sas.expressions.visuals.DataSourceTreeInterface containing the data sources that can be added in the Expression Editor (null allowed if not supported)

### getBusinessDataSourceTree

    public com.sas.expressions.visuals.DataSourceTreeInterface getBusinessDataSourceTree()

  Description copied from interface: `CalculatedItemMetadataInterface`
  Get the DataSource tree model from the Business (Data Item) view of the business model

  Specified by:
    `getBusinessDataSourceTree` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getBusinessDataSourceTree` in interface `CalculatedObjectFactoryInterface`
  Returns:
    a com.sas.expressions.visuals.DataSourceTreeInterface containing the data sources that can be added in the Expression Editor (null allowed if not supported)

### getPromptDataSourceTree

    public com.sas.expressions.visuals.DataSourceTreeInterface getPromptDataSourceTree()

  Description copied from interface: `CalculatedItemMetadataInterface`
  Get the DataSource tree model containing the prompts of the business model

  Specified by:
    `getPromptDataSourceTree` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getPromptDataSourceTree` in interface `CalculatedObjectFactoryInterface`
  Returns:
    a com.sas.expressions.visuals.DataSourceTreeInterface containing the data sources that can be added in the Expression Editor (null allowed if not supported)

### getDataSourceTree

    public com.sas.expressions.visuals.DataSourceTreeInterface getDataSourceTree()

  Description copied from interface: `CalculatedItemMetadataInterface`
  Get the Default DataSource tree model for this business model

  Specified by:
    `getDataSourceTree` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getDataSourceTree` in interface `CalculatedObjectFactoryInterface`
  Returns:
    a com.sas.expressions.visuals.DataSourceTreeInterface containing the data sources that can be added in the Expression Editor (null allowed if not supported)

### getFunctionListTree

    public com.sas.expressions.visuals.FunctionTreeInterface getFunctionListTree()

  Description copied from interface: `CalculatedItemMetadataInterface`
  Get the Category Tree with Function Lists model

  Specified by:
    `getFunctionListTree` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getFunctionListTree` in interface `CalculatedObjectFactoryInterface`
  Returns:
    a com.sas.expressions.visuals.FunctionTreeInterface containing the Categories with Functions that can be added in the Expression Editor (null allowed if not supported)

### getOperationList

    public com.sas.expressions.visuals.OperationListInterface getOperationList()

  Description copied from interface: `CalculatedItemMetadataInterface`
  Get the Operations List model

  Specified by:
    `getOperationList` in interface `CalculatedItemMetadataInterface`
  Specified by:
    `getOperationList` in interface `CalculatedObjectFactoryInterface`
  Returns:
    a com.sas.expressions.visuals.OperationListInterface containing the Operations that can be added in the Expression Editor (null allowed if not supported)

### getDataItems

    public java.util.List getDataItems(boolean includeBaseModels)

  returns a list of all the DataItems

  Specified by:
    `getDataItems` in interface `CalculatedObjectFactoryInterface`

### getBusinessModelCalculatedItemObjects

    public java.util.List getBusinessModelCalculatedItemObjects(boolean includeBaseModels)

  Specified by:
    `getBusinessModelCalculatedItemObjects` in interface `CalculatedObjectFactoryInterface`

### removeBusinessModelCalculatedItemObject

    public void removeBusinessModelCalculatedItemObject(java.lang.Object bmObject)

  Specified by:
    `removeBusinessModelCalculatedItemObject` in interface `CalculatedObjectFactoryInterface`

### newBusinessModelCalculatedItemObject

    public java.lang.Object newBusinessModelCalculatedItemObject()

  Specified by:
    `newBusinessModelCalculatedItemObject` in interface `CalculatedObjectFactoryInterface`

### newBusinessModelCalculatedItemObject

    public java.lang.Object newBusinessModelCalculatedItemObject(CalculatedItemInterface item)

  Specified by:
    `newBusinessModelCalculatedItemObject` in interface `CalculatedObjectFactoryInterface`

### newCalculatedItem

    public CalculatedItemInterface newCalculatedItem(CalculatedItemInterface toBeCloned)

  Specified by:
    `newCalculatedItem` in interface `CalculatedObjectFactoryInterface`

### updateCalculatedItemFromExprValues

    public boolean updateCalculatedItemFromExprValues(CalculatedItemInterface item,
                                                      java.lang.String id,
                                                      java.lang.String label,
                                                      java.lang.String desc,
                                                      int exprType,
                                                      java.lang.String text)

  Specified by:
    `updateCalculatedItemFromExprValues` in interface `CalculatedObjectFactoryInterface`

### updateCalculatedItemFromCalcValues

    public boolean updateCalculatedItemFromCalcValues(CalculatedItemInterface item,
                                                      java.lang.String id,
                                                      java.lang.String label,
                                                      java.lang.String desc,
                                                      int calcType,
                                                      java.lang.String text)

  Specified by:
    `updateCalculatedItemFromCalcValues` in interface `CalculatedObjectFactoryInterface`

### updateCalculatedItemFromBusinessModelObject

    public boolean updateCalculatedItemFromBusinessModelObject(CalculatedItemInterface item,
                                                               java.lang.Object bmObject)

  Specified by:
    `updateCalculatedItemFromBusinessModelObject` in interface `CalculatedObjectFactoryInterface`

### setFormat

    public static boolean setFormat(com.sas.iquery.metadata.business.DataItem dataItem,
                                    java.lang.String format)

  sets the format on the dataitem with checking to see if format is writable first

  Parameters:
    `dataitem` -
    `format` -
  Returns:
    returns TRUE if successful, FALSE if the format could not be set

### updateBusinessModelObjectFromCalculatedItem

    public boolean updateBusinessModelObjectFromCalculatedItem(java.lang.Object bmObject,
                                                               CalculatedItemInterface item)

  Specified by:
    `updateBusinessModelObjectFromCalculatedItem` in interface `CalculatedObjectFactoryInterface`

### getFormatFromResources

    public java.lang.String getFormatFromResources(java.lang.Object bmObject)

  Specified by:
    `getFormatFromResources` in interface `CalculatedObjectFactoryInterface`

### getExpressionTypeNames

    public java.lang.String[] getExpressionTypeNames()

  Specified by:
    `getExpressionTypeNames` in interface `CalculatedObjectFactoryInterface`

### getCalcItemTypeNames

    public static java.lang.String[] getCalcItemTypeNames(boolean isOLAP)

### getExpressionTypeValues

    public int[] getExpressionTypeValues()

  Specified by:
    `getExpressionTypeValues` in interface `CalculatedObjectFactoryInterface`

### getCalcItemTypeValues

    public static int[] getCalcItemTypeValues(boolean isOLAP)

### convertToCalcItemType

    public static int convertToCalcItemType(int expressionType,
                                            boolean isOLAP)

### getExpressionTypeLabel

    public static java.lang.String getExpressionTypeLabel(int expressionType,
                                                          boolean isOlap)

### convertToExpressionType

    public static int convertToExpressionType(int calculatedItemType,
                                              boolean isOLAP)

### getDataSources

    public java.util.List getDataSources(boolean includeBaseModels)

  Returns a list of all logical getDataSources

  Specified by:
    `getDataSources` in interface `CalculatedObjectFactoryInterface`

### getBusinessObjectDisplayName

    public java.lang.String getBusinessObjectDisplayName(java.lang.Object item)

  Specified by:
    `getBusinessObjectDisplayName` in interface `CalculatedObjectFactoryInterface`

### getBusinessObjectDescription

    public java.lang.String getBusinessObjectDescription(java.lang.Object bmObject)

  Specified by:
    `getBusinessObjectDescription` in interface `CalculatedObjectFactoryInterface`

### getBusinessObjectTipText

    public java.lang.String getBusinessObjectTipText(java.lang.Object bmObject)

  Specified by:
    `getBusinessObjectTipText` in interface `CalculatedObjectFactoryInterface`

### getBusinessObjectInsertName

    public java.lang.String getBusinessObjectInsertName(java.lang.Object item)

  Specified by:
    `getBusinessObjectInsertName` in interface `CalculatedObjectFactoryInterface`

### canBusinessModelObjectHaveChildren

    public boolean canBusinessModelObjectHaveChildren(java.lang.Object bmObject)

  Specified by:
    `canBusinessModelObjectHaveChildren` in interface `CalculatedObjectFactoryInterface`

### getBusinessModelObjectChildren

    public java.util.List getBusinessModelObjectChildren(java.lang.Object bmObject)

  Specified by:
    `getBusinessModelObjectChildren` in interface `CalculatedObjectFactoryInterface`

### canBusinessModelObjectHaveValues

    public boolean canBusinessModelObjectHaveValues(java.lang.Object bmObject)

  Specified by:
    `canBusinessModelObjectHaveValues` in interface `CalculatedObjectFactoryInterface`

### getBusinessModelObjectValues

    public java.util.List getBusinessModelObjectValues(java.lang.Object bmObject)

  Specified by:
    `getBusinessModelObjectValues` in interface `CalculatedObjectFactoryInterface`

### convertBusinessObjectListToValuesList

    protected java.util.List convertBusinessObjectListToValuesList(java.util.List businessObjects,
                                                                   java.lang.String formatString)

### getDataServiceValues

    protected java.util.List getDataServiceValues(com.sas.iquery.metadata.business.DataItem dataItem)

### getBusinessModelObjectValuesToInsert

    public java.lang.String getBusinessModelObjectValuesToInsert(java.lang.Object item)

  Specified by:
    `getBusinessModelObjectValuesToInsert` in interface `CalculatedObjectFactoryInterface`

### getLastInvalidCalculatedItemMessage

    public java.lang.String getLastInvalidCalculatedItemMessage()

  Specified by:
    `getLastInvalidCalculatedItemMessage` in interface `CalculatedObjectFactoryInterface`

### validateCalculatedItem

    public boolean validateCalculatedItem(CalculatedItemInterface item)

  Specified by:
    `validateCalculatedItem` in interface `CalculatedObjectFactoryInterface`

### validateCalculatedItem

    public boolean validateCalculatedItem(CalculatedItemInterface item,
                                          boolean validateText)

  Specified by:
    `validateCalculatedItem` in interface `CalculatedObjectFactoryInterface`

### validateItemCalculation

    public boolean validateItemCalculation(CalculatedItemInterface item)

  Specified by:
    `validateItemCalculation` in interface `CalculatedObjectFactoryInterface`

### validateItemCalculation

    public boolean validateItemCalculation(CalculatedItemInterface item,
                                           boolean validateTextOnServer)

### getBusinessModelObjectImageName

    public java.lang.String getBusinessModelObjectImageName(java.lang.Object value,
                                                            boolean expanded)

  Specified by:
    `getBusinessModelObjectImageName` in interface `CalculatedObjectFactoryInterface`

### getImageIconFactory

    public CalculatedObjectFactoryInterface.ImageIconFactoryInterface getImageIconFactory()

### setImageIconFactory

    public void setImageIconFactory(CalculatedObjectFactoryInterface.ImageIconFactoryInterface imageIconFactory)

### getImageIconByImageName

    public javax.swing.Icon getImageIconByImageName(java.lang.String imageName)

### getImageIconFromIqVisualsBundle

    public javax.swing.Icon getImageIconFromIqVisualsBundle(java.lang.String imageName)

  Specified by:
    `getImageIconFromIqVisualsBundle` in interface `CalculatedObjectFactoryInterface`

### getResourceScope

    public com.sas.iquery.metadata.expr.ResourceScope getResourceScope()

  Specified by:
    `getResourceScope` in interface `CalculatedObjectFactoryInterface`

### setResourceScope

    public void setResourceScope(com.sas.iquery.metadata.expr.ResourceScope scope)

  Specified by:
    `setResourceScope` in interface `CalculatedObjectFactoryInterface`

### getExpressionUtilText

    public java.lang.String getExpressionUtilText(com.sas.iquery.metadata.expr.ExpressionInterface expression)

  Specified by:
    `getExpressionUtilText` in interface `CalculatedObjectFactoryInterface`

### newExpressionUtilExpression

    public com.sas.iquery.metadata.expr.ExpressionInterface newExpressionUtilExpression(java.lang.String text,
                                                                                        int type)

  Specified by:
    `newExpressionUtilExpression` in interface `CalculatedObjectFactoryInterface`

### getLastInvalidExpressionException

    public java.lang.Exception getLastInvalidExpressionException()

  Specified by:
    `getLastInvalidExpressionException` in interface `CalculatedObjectFactoryInterface`

### parseExpression

    public com.sas.iquery.metadata.expr.ExpressionInterface parseExpression(java.lang.String text,
                                                                            int type)

### validateExpression

    public boolean validateExpression(com.sas.iquery.metadata.expr.ExpressionInterface expression)

### validateExpression

    public static void validateExpression(com.sas.iquery.metadata.business.BusinessModel sourceModel,
                                          com.sas.iquery.metadata.expr.ExpressionInterface expression)
                                   throws com.sas.iquery.dataservices.DataServicesException,
                                          com.sas.iquery.metadata.MetadataException

  Throws:
    `com.sas.iquery.dataservices.DataServicesException`
    `com.sas.iquery.metadata.MetadataException`

### validateCalculatedItemOnServer

    public boolean validateCalculatedItemOnServer(CalculatedItemInterface calculatedItem)

  Validates the specified calculated item on the server by building a corresponding data item and then calling down to IQ to validate the data item. This validation includes checking the item's label and expression, and possibly other parts as well.

  Parameters:
    `calculatedItem` - The calculated item to validate on the server
  Returns:
    True if the calculated item validated successfully, false otherwise.

### convertToDataItem

    protected com.sas.iquery.metadata.business.DataItem convertToDataItem(CalculatedItemInterface calculatedItem)

  Converts the specified calculated item to a data item.

  Parameters:
    `calculatedItem` - The calculated item to convert.
  Returns:
    The resulting data item, or null if a problem was encountered.

### getExpressionValues

    public static java.util.List getExpressionValues(com.sas.iquery.metadata.business.BusinessModel sourceModel,
                                                     com.sas.iquery.metadata.expr.ExpressionInterface expression,
                                                     int maxValues)
                                              throws com.sas.iquery.dataservices.DataServicesException,
                                                     com.sas.iquery.metadata.MetadataException

  Throws:
    `com.sas.iquery.dataservices.DataServicesException`
    `com.sas.iquery.metadata.MetadataException`

### getDataItemValues

    public static java.util.List getDataItemValues(com.sas.iquery.metadata.business.DataItem dataItem,
                                                   int maxValues)

### isInterruptedGetPossibleFilterValues

    public static boolean isInterruptedGetPossibleFilterValues(com.sas.iquery.dataservices.DataServicesException e)

### getChildFormats

    public static java.util.List getChildFormats(com.sas.iquery.metadata.business.DataItem dataItem,
                                                 int restrictByType)

  Returns a list of format strings used by the resources of this data item

  Parameters:
    `DataItem` -
    `int` - restrictByType (see ExpressionTypes) use ExpressionTypes.EXP_TYPE_NOT_SET for all
  Returns:
    List (of String formats)

### getChildFormats

    public static java.util.List getChildFormats(com.sas.iquery.metadata.expr.ExpressionInterface expression,
                                                 int restrictByType)

  Returns a list of format strings used by the resources of this data item

  Parameters:
    `DataItem` -
    `int` - restrictByType (see ExpressionTypes) use ExpressionTypes.EXP_TYPE_NOT_SET for all
  Returns:
    List (of String formats)

### getChildFormats

    public java.util.List getChildFormats(java.lang.String expressionText,
                                          int expressionType,
                                          int restrictByType)

  Specified by:
    `getChildFormats` in interface `CalculatedObjectFactoryInterface`

### getDataItemsAndFolders

    public java.util.List getDataItemsAndFolders(boolean includeBaseModels)

  Specified by:
    `getDataItemsAndFolders` in interface `CalculatedObjectFactoryInterface`

### canRemoveAllCalculatedItems

    public boolean canRemoveAllCalculatedItems()

  Specified by:
    `canRemoveAllCalculatedItems` in interface `CalculatedObjectFactoryInterface`

### getMaxOutputObservations

    public int getMaxOutputObservations()

  Description copied from interface: `CalculatedItemMetadataInterface`
  Returns the current maximum number of output observations returned when gathering a list of possible values for a data item or physical item in the data source tree.

  Specified by:
    `getMaxOutputObservations` in interface `CalculatedItemMetadataInterface`
  Returns:
    the maximum number of output observations

### setMaxOutputObservations

    public void setMaxOutputObservations(int max)

  Description copied from interface: `CalculatedItemMetadataInterface`
  Sets the current maximum number of output observations to be returned when gathering a list of possible values for a data item or physical item in the data source tree.

  Specified by:
    `setMaxOutputObservations` in interface `CalculatedItemMetadataInterface`
  Parameters:
    `max` - the new maximum number of output observations
  See Also:
    `Governing`

### finalize

    protected void finalize()

  Overrides:
    `finalize` in class `java.lang.Object`

### isTypeChangeWarningIgnored

    public boolean isTypeChangeWarningIgnored()

### setTypeChangeWarningIgnored

    public void setTypeChangeWarningIgnored(boolean isTypeChangeWarningIgnored)

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.